=== debian/changelog ===
unifrac-tools (1.2-2) unstable; urgency=medium

  * Sneak in CFLAGS via CPPFLAGS to work around missing support of CLFAGS
    in upstream Makefile
    Closes: #1028051

 -- Andreas Tille <tille@debian.org>  Mon, 09 Jan 2023 08:31:31 +0100

unifrac-tools (1.2-1) unstable; urgency=medium

  [ Andreas Tille ]
  * Team Upload.
  * Fix Homepage
    Closes: #1026296
  * New upstream version
  * Standards-Version: 4.6.2 (routine-update)
  * Apply multi-arch hints. + libssu-dev: Add Multi-Arch: same.
  * Refresh patches

  [ Nilesh Patra ]
  * Do not pass -noshlib to ldflags
  * Add patch to enable debug flags

 -- Nilesh Patra <nilesh@debian.org>  Thu, 05 Jan 2023 22:09:46 +0530

unifrac-tools (1.1.3-2) unstable; urgency=medium

  * Team Upload.
  * Do not build unifrac-tools in parallel (Closes: #1026297)

 -- Nilesh Patra <nilesh@debian.org>  Sun, 18 Dec 2022 20:48:16 +0530

unifrac-tools (1.1.3-1) unstable; urgency=medium

  * Delete broken lintian-overrides
  * New upstream version

 -- Andreas Tille <tille@debian.org>  Wed, 30 Nov 2022 08:49:15 +0100

unifrac-tools (1.1.1-4) unstable; urgency=medium

  * Conflicts/Provides/Replaces: libssu-tools
    Closes: #1021284, #1021543

 -- Andreas Tille <tille@debian.org>  Mon, 10 Oct 2022 15:15:26 +0200

unifrac-tools (1.1.1-3) unstable; urgency=medium

  * baseline.patch: fix baseline violation and ftbfs on non-amd64.
    (Closes: #1021115)

 -- Étienne Mollier <emollier@debian.org>  Sun, 02 Oct 2022 15:31:39 +0200

unifrac-tools (1.1.1-2) unstable; urgency=medium

  * Source-only upload.
  * d/control: add myself to uploaders.
  * d/rules: activate the executable bit of executables; fix a test failure.

 -- Étienne Mollier <emollier@debian.org>  Sun, 02 Oct 2022 14:23:52 +0200

unifrac-tools (1.1.1-1) unstable; urgency=medium

  * Initial release (Closes: #1016160)

 -- Andreas Tille <tille@debian.org>  Thu, 28 Jul 2022 12:23:31 +0200
