=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk
export DEB_BUILD_MAINT_OPTIONS=hardening=+all
export PYBUILD_NAME=unifrac

export CPPFLAGS := $(CFLAGS) $(CPPFLAGS)

%:
	dh $@ --no-parallel

override_dh_auto_build:
	mkdir -p $(CURDIR)/debian/tmp/usr/bin
	mkdir -p $(CURDIR)/debian/tmp/usr/lib
	dh_auto_build -- PREFIX=$(CURDIR)/debian/tmp/usr
	chmod +x $(CURDIR)/debian/tmp/usr/bin/*

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	export PATH=${PATH}:$(CURDIR)/debian/tmp/usr/bin ; \
	cd ci ; \
	./crawford_test.sh
endif

override_dh_auto_install:
	mkdir -p $(CURDIR)/debian/tmp/usr/bin
	mkdir -p $(CURDIR)/debian/tmp/usr/lib
	dh_auto_install -- PREFIX=$(CURDIR)/debian/tmp/usr

override_dh_install:
	chrpath -d debian/tmp/usr/bin/ssu
	chrpath -d debian/tmp/usr/bin/faithpd
	chrpath -d debian/tmp/usr/lib/libssu.so*
	dh_install
