=== debian/changelog ===
unifrac-tools (1.3.2-5) unstable; urgency=medium

  * Team upload.
  * Add patch to improve build hardening.

 -- Michael R. Crusoe <crusoe@debian.org>  Thu, 17 Aug 2023 17:01:48 +0200

unifrac-tools (1.3.2-4) unstable; urgency=medium

  * Team upload.
  * Adapt baseline patch even further to enable building on non-x86.

 -- Michael R. Crusoe <crusoe@debian.org>  Thu, 17 Aug 2023 14:54:08 +0200

unifrac-tools (1.3.2-3) unstable; urgency=medium

  [ Adrian Bunk ]
  * Fix baseline violation on amd64 and FTBFS everywhere else

 -- Andreas Tille <tille@debian.org>  Wed, 26 Jul 2023 06:47:41 +0200

unifrac-tools (1.3.2-2) unstable; urgency=medium

  * gcc-13.patch: new: fix build failures with gcc-13 (Closes: #1037879)

 -- Étienne Mollier <emollier@debian.org>  Sun, 23 Jul 2023 11:43:01 +0200

unifrac-tools (1.3.2-1) unstable; urgency=medium

  * New upstream version

 -- Andreas Tille <tille@debian.org>  Thu, 13 Jul 2023 14:28:35 +0200
