=== combined/Makefile ===
--- 
+++ 
@@ -13,10 +13,10 @@
 endif
 
 libssu.o: libssu.c
-	$(CC) -c libssu.c -fPIC
+	$(CC) $(CPPFLAGS) $(CFLAGS) -c libssu.c -fPIC
 
 libssu.so: libssu.o
-	$(CC) -shared -o libssu.so libssu.o -fPIC -ldl
+	$(CC) -shared -o libssu.so libssu.o -fPIC -ldl $(LDFLAGS)
 
 install: libssu.so
 	rm -f ${PREFIX}/lib//libssu.so; cp libssu.so ${PREFIX}/lib/
