=== src/Makefile ===
--- 
+++ 
@@ -118,7 +118,7 @@
 endif
 
 
-CPPFLAGS += -Wall  -std=c++14 -pedantic -I. $(OPT) -fPIC -L$(PREFIX)/lib
+CPPFLAGS += -Wall  -std=c++17 -pedantic -I. $(OPT) -fPIC -L$(PREFIX)/lib
 
 all: api main install
