=== debian/changelog ===
unifrac-tools (1.4-3) unstable; urgency=medium

  * d/clean: new: clean build artifacts. (Closes: #1048281)

 -- Étienne Mollier <emollier@debian.org>  Sun, 03 Dec 2023 13:21:32 +0100

unifrac-tools (1.4-2) unstable; urgency=medium

  * Team Upload.
  * Backport upstream patch to fix FTBFS in unifrac 1.3.

 -- Nilesh Patra <nilesh@debian.org>  Tue, 24 Oct 2023 04:03:49 +0530

unifrac-tools (1.4-1) unstable; urgency=medium

  * Team Upload.
  * New upstream version 1.4
  * Drop gcc-13.patch
  * Refresh/re-diff patches with new version

 -- Nilesh Patra <nilesh@debian.org>  Tue, 24 Oct 2023 00:51:49 +0530
