=== debian/control ===
--- 
+++ 
@@ -13,6 +13,7 @@
                libblas-dev,
                liblapacke-dev,
                chrpath,
+               gfortran,
                python3 <!nocheck>
 Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/med-team/unifrac-tools
